<template>
  <v-row class="pt-2">
    <v-col>
      <v-card outlined class="panel">
        <v-card-title>
          <v-spacer />
          <v-col cols="4">
            <v-text-field
              v-model="search"
              prepend-inner-icon="search"
              label="Kërko"
              single-line
              hide-details
              clearable
              @input="fetchData"
            />
          </v-col>
        </v-card-title>
        <v-data-table
          dense
          :sort-by="'id'"
          :sort-desc="true"
          :options.sync="pagination"
          :server-items-length="totalRecords"
          :loading="loading"
          :items="data"
          :headers="headers"
          show-select
          @item-selected="rowSelected"
          v-model="selected"
        >
          <template v-slot:[`item.actions`]="row">
            <v-btn
              icon
              color="blue"
              dense
              depressed
              @click="editBank(row.item)"
            >
              <v-icon>edit</v-icon>
            </v-btn>
            <v-btn
              icon
              color="red"
              dense
              depressed
              @click="openDeleteBankModal(row.item.id)"
            >
              <v-icon>delete</v-icon>
            </v-btn>
            <f-show-btn
              @click="showBankDiary(row.item.id, row.item.unit_name)"
            />
          </template>
        </v-data-table>
      </v-card>
      <v-dialog
        width="50%"
        height="auto"
        v-model="createBankModal"
        name="create_bank"
      >
        <v-card>
          <create-edit-bank
            @close="closeModal()"
            modal-type="create"
            @reload-banks="fetchData()"
          />
        </v-card>
      </v-dialog>
      <v-dialog
        width="50%"
        height="auto"
        name="edit_bank"
        v-model="editBankModal"
      >
        <v-card>
          <create-edit-bank
            @close="closeModal()"
            modal-type="edit"
            :data="bankData"
            @reload-banks="fetchData()"
          />
        </v-card>
      </v-dialog>
      <v-dialog
        width="30%"
        height="auto"
        v-model="deleteBankModal"
        name="delete_Accounts"
      >
        <v-card>
          <v-card-title class="light">
            A jeni të sigurtë për fshirjen e bankës/arkës ?
          </v-card-title>
          <v-card-actions>
            <v-spacer />
            <v-btn text @click="closeModal">Anullo</v-btn>
            <f-submit-btn
              label="Fshi"
              :disabled="loading"
              @click="deleteBank()"
            />
          </v-card-actions>
        </v-card>
      </v-dialog>
      <portal to="destination">
        <div class="portal-wrapper">
          <h3>
            Bankat
          </h3>
        </div>
      </portal>
      <portal to="cto-topmenu">
        <div style="display: flex; align-content: center;">
          <download-excel
            class="export-button ma-2"
            :data="dataToExport"
            :fields="exportFields"
            worksheet="Bankat"
            :name="`Bankat_${todayDate}`"
          >
            Eksporto<v-icon right dark small>mdi-file-download</v-icon>
          </download-excel>
          <v-btn
            @click="createBankModal = true"
            class="ma-1"
            outlined
            x-small
            fab
          >
            <v-icon>add</v-icon>
          </v-btn>
        </div>
      </portal>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import { Component, Mixins } from 'vue-property-decorator'
import Table from '../../../plugins/table'
import api from '../../../plugins/api'
import FSubmitBtn from '@/components/buttons/FSubmitBtn.vue'
import CreateEditBank from '@/views/Banks/components/CreateEditBank.vue'
import FShowBtn from '@/components/buttons/FShowBtn.vue'

const datatableHeader = [
  {
    value: 'id',
    text: 'Id',
  },
  {
    value: 'unit_name',
    text: 'Emri',
  },
  {
    value: 'unit_code',
    text: 'Kodi',
  },
  {
    value: 'currency',
    text: 'Monedha',
    sortable: false,
  },
  {
    value: 'start_exchange_rate',
    text: 'Kembimi Valutor',
    sortable: false,
  },
  {
    value: 'actions',
    text: 'Veprime',
    sortable: false,
  },
]

const exelHeaders = {
  Id: 'id',
  Emri: 'unit_name',
  Kodi: 'unit_code',
  Monedha: 'currency',
  'Kembimi Valutor': 'start_exchange_rate',
}

@Component({
  components: { CreateEditBank, FSubmitBtn, FShowBtn },
})
export default class Banks extends Mixins(Table) {
  headers = datatableHeader
  bankData?: object = {}
  selected = []
  dialog = false
  type = 'create'
  createBankModal = false
  editBankModal = false
  deleteBankModal = false
  selectBankId = null
  exportFields = exelHeaders
  todayDate = new Date().toLocaleDateString('en-gb')
  filters = [
    {
      prop: 'search',
      value: '',
    },
  ]
  editBank(row: any) {
    this.bankData = row
    this.editBankModal = true
  }

  openDeleteBankModal(id: any) {
    this.deleteBankModal = true
    this.selectBankId = id
  }

  deleteBank() {
    api()
      .delete(`/api/account-management/banks/${this.selectBankId}`)
      .then(() => {
        this.fetchData()
        this.closeModal()
      })
      .catch(error => {
        console.log(error)
      })
      .finally(() => {
        this.loading = false
      })
  }
  prepareQueryParams() {
    const queryParams: any = {}
    this.filters.forEach(filter => {
      if (filter.prop === 'search' && filter.value.length > 0) {
        const searchString = encodeURI(filter.value)
        queryParams.qs = `${searchString}`
      }
    })
    return queryParams
  }

  fetchData() {
    const query = this.prepareQuery(this.prepareQueryParams())
    this.loading = true
    api()
      .get(`/api/account-management/banks/${query}`)
      .then(response => {
        this.data = response.data.data
        this.totalRecords = response.data.meta.total
      })
      .finally(() => (this.loading = false))
  }

  closeModal() {
    this.createBankModal = false
    this.editBankModal = false
    this.deleteBankModal = false
  }

  showBankDiary(id: any, name: any) {
    this.$router.push({
      name: 'BankDiaryDataTable',
      params: { bankId: id, bankName: name },
    })
  }
  rowSelected() {
    // this.$nextTick(() => {
    //   console.log(this.selected)
    // })
  }
  get dataToExport() {
    return this.selected.length != 0 ? this.selected : this.data
  }
}
</script>

<style scoped>
.export-button {
  background-color: #30488b;
  text-transform: uppercase;
  font-size: 80%;
  font-weight: 500;
  color: white;
  padding: 5px 10px;
  border-radius: 5px;
  cursor: pointer;
}
.export-button:hover {
  background-color: rgb(48, 72, 139, 0.95);
}
</style>
